from typing import overload, Any, Callable, TypeVar, Union
from typing import Tuple, List, Sequence, MutableSequence

Callback = Union[Callable[..., None], None]
Buffer = TypeVar('Buffer')
Pointer = TypeVar('Pointer')
Template = TypeVar('Template')

import vtkmodules.vtkCommonCore
import vtkmodules.vtkCommonExecutionModel

class vtkOctreeImageToPointSetFilter(vtkmodules.vtkCommonExecutionModel.vtkPolyDataAlgorithm):
    cell_array_component:'getset_descriptor'
    create_vertices_cell_array:'getset_descriptor'
    process_input_cell_array:'getset_descriptor'
    def CreateVerticesCellArrayOff(self) -> None: ...
    def CreateVerticesCellArrayOn(self) -> None: ...
    def GetCellArrayComponent(self) -> int: ...
    def GetCellArrayComponentMaxValue(self) -> int: ...
    def GetCellArrayComponentMinValue(self) -> int: ...
    def GetCreateVerticesCellArray(self) -> bool: ...
    def GetNumberOfGenerationsFromBase(self, type:str) -> int: ...
    @staticmethod
    def GetNumberOfGenerationsFromBaseType(type:str) -> int: ...
    def GetProcessInputCellArray(self) -> bool: ...
    def IsA(self, type:str) -> int: ...
    @staticmethod
    def IsTypeOf(type:str) -> int: ...
    def NewInstance(self) -> 'vtkOctreeImageToPointSetFilter': ...
    def ProcessInputCellArrayOff(self) -> None: ...
    def ProcessInputCellArrayOn(self) -> None: ...
    @staticmethod
    def SafeDownCast(o:'vtkObjectBase') -> 'vtkOctreeImageToPointSetFilter': ...
    def SetCellArrayComponent(self, _arg:int) -> None: ...
    def SetCreateVerticesCellArray(self, _arg:bool) -> None: ...
    def SetProcessInputCellArray(self, _arg:bool) -> None: ...

class vtkPointSetStreamer(vtkmodules.vtkCommonExecutionModel.vtkPolyDataAlgorithm):
    bucket_id:'getset_descriptor'
    create_vertices_cell_array:'getset_descriptor'
    number_of_buckets:'getset_descriptor'
    number_of_points_per_bucket:'getset_descriptor'
    def CreateVerticesCellArrayOff(self) -> None: ...
    def CreateVerticesCellArrayOn(self) -> None: ...
    def GetBucketId(self) -> int: ...
    def GetBucketIdMaxValue(self) -> int: ...
    def GetBucketIdMinValue(self) -> int: ...
    def GetCreateVerticesCellArray(self) -> bool: ...
    def GetNumberOfBuckets(self) -> int: ...
    def GetNumberOfGenerationsFromBase(self, type:str) -> int: ...
    @staticmethod
    def GetNumberOfGenerationsFromBaseType(type:str) -> int: ...
    def GetNumberOfPointsPerBucket(self) -> int: ...
    def GetNumberOfPointsPerBucketMaxValue(self) -> int: ...
    def GetNumberOfPointsPerBucketMinValue(self) -> int: ...
    def IsA(self, type:str) -> int: ...
    @staticmethod
    def IsTypeOf(type:str) -> int: ...
    def NewInstance(self) -> 'vtkPointSetStreamer': ...
    @staticmethod
    def SafeDownCast(o:'vtkObjectBase') -> 'vtkPointSetStreamer': ...
    def SetBucketId(self, _arg:int) -> None: ...
    def SetCreateVerticesCellArray(self, _arg:bool) -> None: ...
    def SetNumberOfPointsPerBucket(self, _arg:int) -> None: ...

class vtkPointSetToOctreeImageFilter(vtkmodules.vtkCommonExecutionModel.vtkPartitionedDataSetAlgorithm):
    compute_count:'getset_descriptor'
    compute_last_value:'getset_descriptor'
    compute_max:'getset_descriptor'
    compute_mean:'getset_descriptor'
    compute_min:'getset_descriptor'
    compute_sum:'getset_descriptor'
    number_of_points_per_cell:'getset_descriptor'
    process_input_point_array:'getset_descriptor'
    def ComputeCountOff(self) -> None: ...
    def ComputeCountOn(self) -> None: ...
    def ComputeLastValueOff(self) -> None: ...
    def ComputeLastValueOn(self) -> None: ...
    def ComputeMaxOff(self) -> None: ...
    def ComputeMaxOn(self) -> None: ...
    def ComputeMeanOff(self) -> None: ...
    def ComputeMeanOn(self) -> None: ...
    def ComputeMinOff(self) -> None: ...
    def ComputeMinOn(self) -> None: ...
    def ComputeSumOff(self) -> None: ...
    def ComputeSumOn(self) -> None: ...
    def GetComputeCount(self) -> bool: ...
    def GetComputeLastValue(self) -> bool: ...
    def GetComputeMax(self) -> bool: ...
    def GetComputeMean(self) -> bool: ...
    def GetComputeMin(self) -> bool: ...
    def GetComputeSum(self) -> bool: ...
    def GetNumberOfGenerationsFromBase(self, type:str) -> int: ...
    @staticmethod
    def GetNumberOfGenerationsFromBaseType(type:str) -> int: ...
    def GetNumberOfPointsPerCell(self) -> int: ...
    def GetNumberOfPointsPerCellMaxValue(self) -> int: ...
    def GetNumberOfPointsPerCellMinValue(self) -> int: ...
    def GetProcessInputPointArray(self) -> bool: ...
    def IsA(self, type:str) -> int: ...
    @staticmethod
    def IsTypeOf(type:str) -> int: ...
    def NewInstance(self) -> 'vtkPointSetToOctreeImageFilter': ...
    def ProcessInputPointArrayOff(self) -> None: ...
    def ProcessInputPointArrayOn(self) -> None: ...
    @staticmethod
    def SafeDownCast(o:'vtkObjectBase') -> 'vtkPointSetToOctreeImageFilter': ...
    def SetComputeCount(self, _arg:bool) -> None: ...
    def SetComputeLastValue(self, _arg:bool) -> None: ...
    def SetComputeMax(self, _arg:bool) -> None: ...
    def SetComputeMean(self, _arg:bool) -> None: ...
    def SetComputeMin(self, _arg:bool) -> None: ...
    def SetComputeSum(self, _arg:bool) -> None: ...
    def SetNumberOfPointsPerCell(self, _arg:int) -> None: ...
    def SetProcessInputPointArray(self, _arg:bool) -> None: ...

