from typing import overload, Any, Callable, TypeVar, Union
from typing import Tuple, List, Sequence, MutableSequence

Callback = Union[Callable[..., None], None]
Buffer = TypeVar('Buffer')
Pointer = TypeVar('Pointer')
Template = TypeVar('Template')

import vtkmodules.vtkCommonCore
import vtkmodules.vtkCommonExecutionModel

class vtkH5PartReader(vtkmodules.vtkCommonExecutionModel.vtkPolyDataAlgorithm):
    combine_vector_components:'getset_descriptor'
    file_name:'getset_descriptor'
    generate_vertex_cells:'getset_descriptor'
    mask_out_of_time_range_output:'getset_descriptor'
    number_of_coordinate_arrays:'getset_descriptor'
    number_of_point_array_status_arrays:'getset_descriptor'
    number_of_point_arrays:'getset_descriptor'
    xarray:'getset_descriptor'
    yarray:'getset_descriptor'
    zarray:'getset_descriptor'
    def CombineVectorComponentsOff(self) -> None: ...
    def CombineVectorComponentsOn(self) -> None: ...
    def Disable(self, name:str) -> None: ...
    def DisableAll(self) -> None: ...
    def Enable(self, name:str) -> None: ...
    def EnableAll(self) -> None: ...
    def GenerateVertexCellsOff(self) -> None: ...
    def GenerateVertexCellsOn(self) -> None: ...
    def GetCombineVectorComponents(self) -> int: ...
    def GetCoordinateArrayName(self, index:int) -> str: ...
    def GetCoordinateArrayStatus(self, name:str) -> int: ...
    def GetFileName(self) -> str: ...
    def GetGenerateVertexCells(self) -> int: ...
    def GetMaskOutOfTimeRangeOutput(self) -> int: ...
    def GetNumberOfCoordinateArrays(self) -> int: ...
    def GetNumberOfGenerationsFromBase(self, type:str) -> int: ...
    @staticmethod
    def GetNumberOfGenerationsFromBaseType(type:str) -> int: ...
    def GetNumberOfPointArrayStatusArrays(self) -> int: ...
    def GetNumberOfPointArrays(self) -> int: ...
    def GetPointArrayName(self, index:int) -> str: ...
    def GetPointArrayStatus(self, name:str) -> int: ...
    def GetPointArrayStatusArrayName(self, index:int) -> str: ...
    def GetPointArrayStatusArrayStatus(self, name:str) -> int: ...
    def GetXarray(self) -> str: ...
    def GetYarray(self) -> str: ...
    def GetZarray(self) -> str: ...
    def IsA(self, type:str) -> int: ...
    @staticmethod
    def IsTypeOf(type:str) -> int: ...
    def MaskOutOfTimeRangeOutputOff(self) -> None: ...
    def MaskOutOfTimeRangeOutputOn(self) -> None: ...
    def NewInstance(self) -> 'vtkH5PartReader': ...
    @staticmethod
    def SafeDownCast(o:'vtkObjectBase') -> 'vtkH5PartReader': ...
    def SetCombineVectorComponents(self, _arg:int) -> None: ...
    def SetCoordinateArrayStatus(self, name:str, status:int) -> None: ...
    def SetFileName(self, filename:str) -> None: ...
    def SetGenerateVertexCells(self, _arg:int) -> None: ...
    def SetMaskOutOfTimeRangeOutput(self, _arg:int) -> None: ...
    def SetPointArrayStatus(self, name:str, status:int) -> None: ...
    def SetPointArrayStatusArrayStatus(self, name:str, status:int) -> None: ...
    def SetXarray(self, _arg:str) -> None: ...
    def SetYarray(self, _arg:str) -> None: ...
    def SetZarray(self, _arg:str) -> None: ...

